//__INSERT_LICENSE__
// $Id: josephus.cpp,v 1.5 2004/04/05 14:14:12 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Resoluci\'on del problema de Josephus mediante TAD-LISTA 
  de enteros por punteros y con celdas de encabezamiento.
  keywords: lista

  FIN DE DESCRIPCION 
*/

#include <list>
#include <iostream>

using namespace std;

// Debe retornar una lista con las numeros relativos de soldados de
// que van saliendo segun el algoritmo de Josephus. 
void josephus(int n, int m,list<int> &L) {
  //  n = cantidad de soldados
  //  m = salto en el juego

  // Inicialmente carga una lista auxiliar Q con los
  // enteros de 0 a m. 
  list<int> Q;
  for (int j=0; j<n; j++) Q.insert(Q.end(),j);

  // Va simulando el algoritmos extrayendo `soldados' de Q y
  // pasandolos a L. 
  list<int>::iterator p = Q.begin();
  // Sabemos que debemos extraer exactamente `n' soldados de manera
  // que directamente hacemos un lazo de 0 a `n-1'
  for (int k=0; k<n; k++) {
    // Avanzamos `p' m posiciones en `sentido circular' es decir,
    // nunca debe quedar en `end()'!!  Si en algun momento `p' llega a
    // ser `end()' entonces pasamos a `begin()'.
    for (int j=0; j<m-1; j++) 
      if (++p==Q.end()) p = Q.begin(); // Notar que debe ser `++p' (prefijo!!)
    // Extraemos el soldado y lo pasamos a `L'
    L.insert(L.end(),*p);
    // Borra en `sentido circular', es decir, si p es el
    // ultimo elemento, entonces al borrar queda en `end()', en ese caso
    // lo pasamos a `begin()'
    p = Q.erase(p);
    if (p==Q.end()) p = Q.begin();
  }
}

int main() {
  list<int> L;
  josephus(7,4,L);
  list<int>::iterator p = L.begin();
  while (p!=L.end()) cout << *p++ << " ";
  cout << endl;
}
