//__INSERT_LICENSE__
// $Id: junta.cpp,v 1.2 2004/04/05 16:16:59 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Escribir una funci\'on {\tt void junta(list<int> &L, int m)}
  que dada una lista L, agrupa de a m elementos
  dejando su suma IN PLACE. Por ejemplo si la lista L contiene
  L=(1,3,2,4,5,2,2,3,5,7,4,3,2,2), entonces depues de
  junta(L,3) debe quedar L=(6,11,9,14,4). Prestar atenci\'on a no
  usar posiciones inv\'alidas despu\'es de una supresi\'on. El algoritmo
  debe tener un tiempo de ejecuci\'on O(n), donde n es el n\'umero
  de elementos en la lista original. 
  [Tomado en el examen final del 1/8/2002] 
  keywords: lista

  FIN DE DESCRIPCION 
*/

#include <list>
#include <iostream>

using namespace std;

void junta(list<int> &L, int m) {
  list<int>::iterator p = L.begin();
  while (p!=L.end()) {
    int sum = 0;
    // Suma `m' elementos y los elimina 
    for (int j=0; j<m; j++) {
      sum += *p;
      p = L.erase(p);
      // Atencion podrian quedar menos de `m' elementos
      // en la lista. En ese caso llegamos a end() y
      // debemos salir del lazo. 
      if (p==L.end()) break;
    }
    // Inserta e incrementa a `p' de manera de quedar apuntando
    // al comienzo de la siguiente subsecuencia. 
    p = L.insert(p,sum); p++;
  }
}

void printl(list<int> &L) {
  list<int>::iterator p = L.begin();
  while (p!=L.end()) cout << *p++ << " ";
  cout << endl;
}

int main() {
  list<int> L;
  int v[] = {10,1,15,7,2,19,15,16,11,15,9,13,3,7,6,12,1,-1};
  int *vp = v;
  while (*vp!=-1) L.insert(L.end(),*vp++);
  cout << "Lista inicial: ";
  printl(L);
  junta(L,3);
  cout << "Lista agrupada: ";
  printl(L);
}
