//__INSERT_LICENSE__
// $Id: lexico.cpp,v 1.6 2004/04/05 16:18:21 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Dadas dos listas de enteros L1 y L2, escribir una funci\'on {\tt
  bool lexico(list<int> &L1, list<int> &L2)} que retorna ``true'' si
  la lista L1 es mayor que la L2 en sentido lexicogr\'afico, y
  ``false'' en caso contrario.
  [Ejercicio tomado en el 1er parcial 2002, 16/04/02.]
  keywords: lista

  FIN DE DESCRIPCION
*/

/*
  El orden lexicogr\'afico es similar al orden alfab\'etico y puede
  definirse de la siguiente manera:

  1) si las dos listas son vacias, entonces son iguales (valor
  de retorno ``false'');

  2) si una de las listas es vacia (digamos L1) y la otra (L2)
  no lo es, entonces L1 es mayor (retornar ``true'');

  3) Si las dos listas no son vacias, y los primeros elementos
  son diferentes (digamos $a_1$ y $b_1$), entonces el valor
  de retorno es $a_1$ > $b_1$.  Si los dos primeros elementos
  fueran iguales, entonces el valor de retorno ser\'a el
  correspondiente a las listas que se obtienen eliminando
  los primeros elementos.

  Asi, por ejemplo,

  a) Si L1 = [1 3 2 4 6] y L2 = [1 3 2 5], entonces L2 > L1 y
  LEXICORD (L1, L2) retorna ``false'';

  b) Si L1 = [1 3 3 4 5] y L2 = [1 3 3], entonces L1 > L2 y
  LEXICORD (L1, L2) retorna ``true'';

  c) Si L1 = [1 3 3 4] y L2 = [1 3 3 4], entonces L1 = L2 y
  LEXICORD (L1, L2) retorna ''false'';

 */

#include <list>
#include <iostream>
#include "./util.h"

using namespace std;

int lexico1(list<int> &L1, list<int> &L2) {
  list<int>::iterator p1 = L1.begin(),
    p2 = L2.begin();
  while (p1!=L1.end() && p2!=L2.end()) {
    if (*p1 > *p2) return 1;
    else if (*p1 < *p2) return -1;
    p1++; p2++;
  }
  return (p1!=L1.end() ? 1 : p2!=L2.end() ? -1 : 0);
}

bool lexico(list<int> &L1, list<int> &L2) {
  return lexico(L1,L2)>0;
}

int main() {
  list<int> L1, L2;
  int stat[]={0,0,0};
  for (int j=0; j<20; j++) {
    L1.clear();
    L2.clear();
    randl(L1,5,10.0);
    randl(L2,5,10.0);
    int comp = lexico1(L1,L2);
    stat[comp+1]++;
    if (true) {
      cout << "L1: ";
      printl(L1);
      cout << "L2: ";
      printl(L2);
      cout << "L1 " << (comp==1 ? ">" : comp==-1 ? "<" : "=") << " L2\n";
      cout << "------------\n";
    }
  }
  cout << "L1 > L2: " << stat[2] << " veces\n";
  cout << "L1 = L2: " << stat[1] << " veces\n";
  cout << "L1 < L2: " << stat[0] << " veces\n";
}
