//__INSERT_LICENSE__
// $Id: parent.cpp,v 1.3 2004/04/05 16:14:00 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Control de par\'entesis en una expresi\'on algebraica usando
  TAD-PILA de caracteres. Por ``parentizaci\'on'' en una expresi\'on
  algebraica consideramos los simbolos: par\'entisis, corchetes y
  llaves.

  FIN DE DESCRIPCION
*/

/*
  La cadena leida (caracter a caracter) puede contener otros
  simbolos. Pero, para el control, prestamos atenci\'on s\'olo a los
  caracteres de parentizaci\'on, de los cuales:
 
  a) si el simbolo leido es ``abierto'', entonces se lo almacena a la
     espera de encontrar un ``cerrado'';

  b) si el simbolo leido es ``cerrado'', entonces se determina si el
     ULTIMO simbolo ``abierto'' almacenado es del mismo tipo. Si lo
     son, entonces ambos parentizan correctamente, no hace falta
     considerarlos ulteriormente, y se prosigue evaluando el resto de
     la cadena. Si no lo son, entonces, la cadena estar\'a mal
     parentizada.

  En consecuencia, el TAD a usar sera tal que ``el \'ultimo en entrar,
  es el primero en salir'', o sea, una PILA.  keywords: pila
 */

#include <stack>
#include <iostream>

using namespace std;

int main() {
  int N=100;
  char line[N];
  stack<char> P;
  while (true) {
    while (!P.empty()) P.pop();
    cout << "Ingrese expresion: > ";
    cin.getline(line,N);
    int n = strlen(line);
    char *p = line;
    while (*p!='\0') {
      if (*p == '(') P.push(')');
      else if (*p == '{') P.push('}');
      else if (*p == '[') P.push(']');
      else if (*p == ']' || *p == '}' || *p == ')') {
	if (!P.empty() && *p == P.top()) P.pop();
	else break;
      }
      p++;
    }
    if (P.empty() && *p=='\0') cout << "Los parentesis matchean bien.\n";
    else cout << "Los parentesis NO matchean bien.\n";
  }
}
