//__INSERT_LICENSE__
// $Id: parimpa.cpp,v 1.2 2004/04/05 16:19:49 mstorti Exp $

/* 
   COMIENZO DE DESCRIPCION 

   Escribir una funci\'on {\tt void encolar\_trabajo(queue<int>
   par,queue<int> impar,int job)} que, dado un c\'odigo de trabajo n
   lo pone o bien en la cola {\tt par}, o bien en la cola {\tt impar},
   dependiendo del n\'umero.  Escribir un procedimiento {\tt int
   siguiente_trabajo(queue<int> par,queue<int> impar)} que obtiene el
   siguiente trabajo a procesar, dando mayor prioridad a la cola {\tt
   par}.
   keywords: cola 

   FIN DE DESCRIPCION
*/

#include <queue>
#include <iostream>
#include "./util.h"

using namespace std;

void encolar_trabajo(queue<int> &par,queue<int> &impar,int job) {
  if (job % 2) impar.push(job);
  else par.push(job);
}

int siguiente_trabajo(queue<int> &par,queue<int> &impar) {
  queue<int> *q = NULL;
  if (!par.empty()) q = &par;
  else if (!impar.empty())  q = &impar;
  if (q) {
    int job = q->front();
    q->pop();
    return job;
  } else return -1;
}

int main() {
  queue<int> par,impar;
  int job;
  // Simula sistema de colas
  for (int j=0; j<100; j++) {
    // Tira la moneda para saber su pone trabajo
    // o saca trabajo
    if (drand()<0.5) {
      job = irand(100);
      encolar_trabajo(par,impar,job);
      cout << "Pone trabajo " << job << " en cola\n";
    } else {
      cout << "Saca trabajo. ";
      job = siguiente_trabajo(par,impar);
      if (job==-1) 
	cout << "No hay mas trabajos en cola\n";
      else cout << "Procesando trabajo " << job << endl;
    }
  }
}
