//__INSERT_LICENSE__
// $Id: particiona.cpp,v 1.2 2004/04/05 16:20:43 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Usando las operaciones de Lista, escribir una funcion
  particiona(list<int> &L,int a) el cual, dada una lista de enteros L
  reemplace aquellos que son mayores que `a' por una sucesi\'on de
  elementos menores o iguales que `a' manteniendo la suma total
  constante.
  [Ejercicio tomado en el Ex\'amen Final del 05/07/01]
  keywords: lista
  
  FIN DE DESCRIPCION
*/

/*
  Se propone el siguiente algoritmo: recorrer la lista y, cada vez que
  se encuentra un elemento `x>a' suprimirlo y reemplazarlo por `a'
  tantas veces como entren en `x' y finalmente el resto, por ejemplo,
  si `x=7' y `a=2', entonces se debe reemplazar ese 7 por la secuencia
  `2,2,2,1'. En la lista final NO deben quedar elementos mayores que
  `a'.  Por ejemplo, si L=[2,5,2,6,4,1,9,6,3,2], entonces PARTICIONA
  (L,4) debe retornar L=[2,4,1,2,4,2,4,1,4,4,1,4,2,3,2];
*/

#include <list>
#include <iostream>
#include "./util.h"

using namespace std;

void particiona(list<int> &L, int a) {
  list<int>::iterator p = L.begin();
  while (p!=L.end()) {
    // Despues de cada ejecucion del cuerpo de este lazo
    // si *p<=a entonces p queda apuntando al siugiente
    // si *p>a entonces *p es descompuesto en una serie
    // valores  y p queda apuntando al elemento _siguiente_
    // a la secuencia. 
    int w = *p;
    if (w>a) {
      // Eliminamos el elemento
      p = L.erase(p);
      // Este lazo inserta tantos valores de a como entren en `*p'
      while (w>a) { p = L.insert(p,a); p++; w -= a; }
      // Inserta el resto (si es >0)
      if (w) { p = L.insert(p,w); p++; }
    } else p++;
  }
}

int main() {
  list<int> L;
  randl(L,10,5.0);
  cout << "Antes de particionar: ";
  printl(L);
  particiona(L,3);
  cout << "Despues de particionar: ";
  printl(L);
}
