//__INSERT_LICENSE__
// $Id: reemplaza.cpp,v 1.2 2004/04/05 14:14:12 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Dada una lista con enteros `L' y dos listas `SEQ' y `REEMP' escribir
  una funcion `void reemplaza(list<int> &L, list<int> &seq, list<int> &reemp)' que
  busca todas las secuencias de `seq' en `L' y las reemplaza por
  `reemp'.  Por ejemplo, si L=(1 2 3 4 5 1 2 3 4 5 1 2 3 4 5), seq=(4 5
  1) y reemp=(9 7 3), entonces despues de llamar a `reemplaza' debe quedar
  L=(1 2 3 9 7 3 2 3 9 7 3 2 3 4 5). Este procedimiento tiene un efecto
  equivalente a la fucion `reemplazar' de los editores de texto.
  [Tomado el 1er parcial, 16 abril 2002]
  keywords: lista

  FIN DE DESCRIPCION
*/

/*
  SOLUCION 1
  ==========

  Se sugiere el siguiente algoritmo. Recorrer la lista L con una
  posicion `p' y `SEQ' con una posicion `q' hasta que `p' llegue al fin
  de `L'. En todo momento se mantiene una cola `c' con los ultimos
  elementos de L que coinciden con los de `SEQ'.  En el siguiente paso
  se pueden dar tres posibilidades.

  1./ Si llegamos al fin de `SEQ', entonces toda la lista `SEQ' estaba
  en `L' y por lo tanto insertamos la lista `REEMP' en la posicion `p'
  de `L'. Tambien vaciamos 'C'. 

  2./ Si el elemento en `q' es igual al que esta en `p' entonces
  suprimimos al elemento de `L' y lo ponemos en la cola `C'. Tambien
  avanzamos la posicion `q' en `REEMP'.

  3./ Si el elemento en `q' NO es igual al que esta en `p' entonces
  insertamos toda la cola `C' en l lista `L' posicion `p' y reseteamos
  la posicion `q' al principio de `SEQ'.
 */

#include <list>
#include <queue>
#include <iostream>
#include "./util.h"

using namespace std;

void reemplaza(list<int> &L,list<int> &seq, list<int> &reemp)  {
  queue<int> Q;
  list<int>::iterator p,q,r;

  // Inicializa posiciones
  p = L.begin();
  q = seq.begin();

  // Recorre `L'
  while (p!=L.end()) {

    // 1./ Llegamos al fin de `SEQ' porque todo `SEQ' esta en `L'
    if (q == seq.end()) {
      // Vaciamos `C'
      while (!Q.empty()) Q.pop();
      // Q.clear();
      r = reemp.begin();
      // Insertamos `REEMP' en `L'
      while(r!=reemp.end()) p = L.insert(p++,*r++);

      // Reseteamos la posicion `q' en `seq'
      q = seq.begin();

    // 2./ Hay un elemento mas en `L' igual al de `seq'
    } else if (*p==*q) {
      // Lo ponemos en la cola 
      Q.push(*p);
      // Lo suprimimos
      p = L.erase(p);
      // Avanzamos
      q++;
    } else {
      // 3./ Los elementos no son iguales 
      while (!Q.empty()) {
	p = L.insert(p,Q.front());
	Q.pop();
	p++;
      }
      p++;
    }
  }
  while (!Q.empty()) {
    p = L.insert(p,Q.front());
    Q.pop();
    p++;
  }
}

int main() {
  list<int> L,seq,reemp;
  int v[] = {1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,
	     1,2,3,4,5,1,2,3,4,5,-1};
  int vs[] = {4,5,1,-1};
  insertl(L,v,-1);
  int vr[] = {9,7,3,-1};
  cout << "Antes de reemplaza: ";
  printl(L);
  insertl(seq,vs,-1);
  insertl(reemp,vr,-1);
  reemplaza(L,seq,reemp);
  cout << "Despues de reemplaza: ";
  printl(L);
}
