//__INSERT_LICENSE__
// $Id: refina.cpp,v 1.5 2004/04/05 16:14:00 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION
  
  (a) Escriba un procedimiento
  REFINA (delta: real; var L:lista) tal que dada una lista
  de reales clasificados de menor a mayor $L$, REFINA
  inserta elementos entre los de $L$, de modo tal que la
  diferencia m\'axima entre elementos de la lista final
  sea menor o igual que delta;
  (b) Escriba un procedimiento
  DESREFINA (delta: real; var L:lista) tal que dada una
  lista de reales clasificados de menor a mayor
  L, REFINA suprime elementos entre los de $L$, de modo tal que
  la diferencia minima entre elementos de la lista final
  sea mayor o igual que delta.
  keywords: lista

  FIN DE DESCRIPCION
*/

#include <list>
#include <iostream>
#include <cassert>
#include <map>
#include "./util.h"

using namespace std;

void refina (list<double> &L, double delta) {
  list<double>::iterator p = L.begin(), q;
  while (true) {
    double wp = *p++ + delta;
    if (p==L.end()) break;
    double wq = *p;
    while (wp < wq) {
      p = L.insert(p,wp); p++;
      wp += delta;
    }
  }
}

void desrefina (list<double> &L, double delta) {
  list<double>::iterator p = L.begin(), q;
  while (p!=L.end()) {
    q = p; q++;
    while (q!=L.end() && *q < *p+delta) q = L.erase(q);
    p++;
  }
}

int main() {
  list<double> L;
  double delta1 = 5.0, 
    delta2 = 5.0*delta1;
  int n = 10;
  for (int j=0; j<10; j++) {
    L.clear();
    double x = 0.;
    for (int j=0; j<n; j++) {
      x += drand()*delta2;
      L.insert(L.end(),x);
    }
    cout << "Antes de refina: ";
    printl(L);

    refina(L,delta1);
    cout << "Despues de refina: ";
    printl(L);

    desrefina(L,delta2);
    cout << "Despues de desrefina: ";
    printl(L);
  }
}
