//__INSERT_LICENSE__
// $Id: rejunta.cpp,v 1.2 2004/04/05 14:14:12 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Usando las operaciones de Lista, escribir una funcion
  void rejunta(list<int> &L, int a) que, dada una lista de
  enteros L, agrupe elementos de tal manera que en L queden
  solo elementos mayores o iguales que `a'. El algoritmo
  recorre la lista y, cuando encuentra un elemento menor,
  empieza a agrupar el elemento con los siguientes hasta
  llegar a `a' o hasta que se acabe la lista.  Por ejemplo,
  si L=[3,4,2,4,1,4,4,3,2,2,4,1,4,1,4,4,1,4,4,2], entonces
  REJUNTA (L,10) da L=[13,12,13,10,10]. En la lista final
  NO deben quedar elementos menores que `a' salvo,
  eventualmente, el \'ultimo.
  [Ejercicio tomado en el Ex\'amen Final del 05/07/01]
  keywords: lista
  
  FIN DE DESCRIPCION
*/

#include <list>
#include <iostream>
#include "./util.h"

using namespace std;

void rejunta(list<int> &L, int a) {
  list<int>::iterator p = L.begin();
  while (p!=L.end()) {
    if (*p>a) p++;
    else {
      int sum=0;
      while (p!=L.end() && sum<a) {
	sum += *p;
	p = L.erase(p);
      }
      p = L.insert(p,sum);
      p++;
    }
  }
}

int main() {
  list<int> L;
  for (int j=0; j<10; j++) {
    L.clear();
    randl(L,4,10.0);
    cout << "Antes de rejunta: ";
    printl(L);
    rejunta(L,3);
    cout << "Despues de rejunta: ";
    printl(L);
  }
}
